/// <reference types="koa__router" />
/// <reference types="node" />
import { Middleware } from "koa";
import Router from "@koa/router";
import { Server } from "http";
type Enumerate<N extends number, Acc extends number[] = []> = Acc["length"] extends N ? Acc[number] : Enumerate<N, [...Acc, Acc["length"]]>;
type IntRange<F extends number, T extends number> = F extends T ? F : Exclude<Enumerate<T>, Enumerate<F>> extends never ? never : Exclude<Enumerate<T>, Enumerate<F>> | T;
export type StatusCode1xx = IntRange<100, 199>;
export type StatusCode2xx = IntRange<200, 299>;
export type StatusCode3xx = IntRange<300, 399>;
export type StatusCode4xx = IntRange<400, 499>;
export type StatusCode5xx = IntRange<500, 599>;
export type StatusCode = StatusCode1xx | StatusCode2xx | StatusCode3xx | StatusCode4xx | StatusCode5xx;
export type Response<Status extends StatusCode, Type> = {
    status: Status;
    body: Type;
};
export type ServerConfig = {
    middleware?: Middleware[];
    router: Router;
    port: number;
};
export declare function startServer(config: ServerConfig): Server;
export {};
