"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.startServer = void 0;
const tslib_1 = require("tslib");
const cors_1 = tslib_1.__importDefault(require("@koa/cors"));
const koa_1 = tslib_1.__importDefault(require("koa"));
const koa_body_1 = tslib_1.__importDefault(require("koa-body"));
function startServer(config) {
    const app = new koa_1.default();
    app.use((0, cors_1.default)());
    app.use((0, koa_body_1.default)());
    const middleware = config.middleware ?? [];
    middleware.forEach(it => app.use(it));
    app.use(config.router.allowedMethods());
    app.use(config.router.routes());
    const server = app.listen(config.port, () => {
        const address = server.address();
        console.info("server listening", { address });
    });
    return server;
}
exports.startServer = startServer;
//# sourceMappingURL=server.js.map